%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018-2019  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Created_MPC_ID = DB_MPC_Create_RBE2(Ind_Node, Dep_Node_list, Dep_DOFs)

% Счетчик db_Next_MPC_Number обновляется вне данной функции после ее вызова

global db_Next_MPC_Number;
global ErrCode;

global DB_MPC;
global AST_NODES;

global AT_MPC;
global AT_NODES;

global AT_Page_Prealloc_Size;

Created_MPC_ID = [];

Dep_Node_list = unique(Dep_Node_list);

% Проверка существования в базе MPC со следующим номером
if (DB_MPC_Exist(db_Next_MPC_Number))
    fprintf (1, '\nОшибка функции DB_MPC_Create_RBE2: MPC с номером %i уже существует в базе !\n', db_Next_MPC_Number);
    ErrCode = -1;
    return;
end

% Проверка существования в базе независимого узла
if (~DB_Node_Exist(Ind_Node))
    fprintf (1, '\nОшибка функции DB_MPC_Create_RBE2: узел с номером %i отсутствует в базе !\n', Ind_Node);
    ErrCode = -1;
    return;
end

% Проверка существования в базе зависимых узлов
for i=1:size(Dep_Node_list,1)
    if (~DB_Node_Exist(Dep_Node_list(i)))
        fprintf (1, '\nОшибка функции DB_MPC_Create_RBE2: узел с номером %i отсутствует в базе !\n', Dep_Node_list(i));
        ErrCode = -1;
        return;
    end
end

% Проверка на отсутствие независимого узла в списке зависимых
if (~isempty(intersect(Ind_Node, Dep_Node_list)))
    fprintf (1, '\nОшибка функции DB_MPC_Create_RBE2: независимый узел [%i] содержится в списке зависимых узлов !\n', Ind_Node);
    ErrCode = -1;
    return;
end

% Выделение памяти
if (isempty(DB_MPC))
    AT_MPC = zeros(AT_Page_Prealloc_Size,1,'uint64');
end
if (db_Next_MPC_Number >= size(AT_MPC,1))
    AT_MPC(db_Next_MPC_Number + AT_Page_Prealloc_Size,1) = 0;
end

% Следующий индекс в базе
Next_DB_index = size(DB_MPC,1) + 1;

% Создание записи в базе
DB_MPC{Next_DB_index,1}.type = 'RBE2';
DB_MPC{Next_DB_index,1}.ID = db_Next_MPC_Number;
DB_MPC{Next_DB_index,1}.ind_grid = Ind_Node;
DB_MPC{Next_DB_index,1}.dep_grid = sortrows(Dep_Node_list,1);
DB_MPC{Next_DB_index,1}.dep_DOF = Dep_DOFs;

% Внесение изменений в таблицу ассоциативности узлов
AST_NODES{AT_NODES(DB_MPC{Next_DB_index}.ind_grid)}.MPC_list = Union_Column(AST_NODES{AT_NODES(DB_MPC{Next_DB_index}.ind_grid)}.MPC_list, db_Next_MPC_Number);
    
for i=1:size(DB_MPC{Next_DB_index}.dep_grid, 1)
    AST_NODES{AT_NODES(DB_MPC{Next_DB_index}.dep_grid(i))}.MPC_list = Union_Column(AST_NODES{AT_NODES(DB_MPC{Next_DB_index}.dep_grid(i))}.MPC_list, db_Next_MPC_Number);
end

% Создание ссылки в адресной таблице
AT_MPC(db_Next_MPC_Number) = Next_DB_index;

% Номер созданного MPC
Created_MPC_ID = db_Next_MPC_Number;
